﻿using ProjectMonorail.CollectionGenericObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ProjectMonorail.Drawnings;

public class MassiveGenericObjects<T> : ICollectionGenericObjects<T>
    where T : class
{
    /// <summary>
    /// Массив объектов, которые храним
    /// </summary>
    private T?[] _collection;
    public int Count => _collection.Length;
    /// <summary>
    /// Установка максимального кол-ва объектов
    /// </summary>
    public int SetMaxCount
    {
        set
        {
            if (value > 0)
            {
                if (_collection.Length > 0)
                {
                    Array.Resize(ref _collection, value);
                }
                else
                {
                    _collection = new T?[value];
                }
            }
        }
    }

    /// <summary>
    /// Конструктор
    /// </summary>
    public MassiveGenericObjects()
    {
        _collection = Array.Empty<T?>();
    }

    public T? Get(int position)
    {
        if (position < 0 || position >= _collection.Length)
            return null;
        return _collection[position];
    }
    public int Insert(T obj)
    {
        for (int i = 0; i < _collection.Length; i++)
        {
            if (_collection[i] == null)
            {
                _collection[i] = obj;
                return i;
            }
        }
        return -1;
    }

    public bool Insert(T obj, int position)
    {
        if (position < 0 || position >= _collection.Length)
            return false;
        if (_collection[position] == null)
        {
            _collection[position] = obj;
            return true;
        }
        for (int i = position; i < _collection.Length; i++) 
        {
            if (_collection[i] == null)
            {
                _collection[i] = obj;
                return true;
            }
        }
        for (int i = 0; i < position; i++) 
        {
            if (_collection[i] == null)
            {
                _collection[i] = obj;
                return true;
            }
        }
        return false;
    }

    public T? Remove(int position)
    {
        if (position < 0 || position >= _collection.Length || _collection[position] == null) // проверка позиции и наличия объекта
            return null;
        T? temp = _collection[position];
        _collection[position] = null;

        return temp;
    }
}